    --[[
    options format:
     options = {
     {"identifier", "String", function() end}
     }
   ]]

function Library.LibFluff.Select(name, parent)
  local select = UI.CreateFrame("Frame", name, parent) -- This actually just to be able to set visible
  select.enabled = true
  select.selected = nil
  select.current = UI.CreateFrame("Text", name .. " Current", select)
  select.drop = UI.CreateFrame("Text", name .. " dropicon", select)
  select.drop:SetText("v")
  select.drop:SetPoint("CENTERRIGHT", select, "CENTERRIGHT")
  select.drop:SetLayer(10)
  select.drop:SetFontSize(8)
  select.current:SetAllPoints()
  select.current:SetText("Select...")
  select.mouseoverColor = {r = 0.2,g = 0.2,b = 0.2,a = 1}
  select.color = {r = 0,g = 0,b = 0,a = 0.8}
  select:SetHeight(20)
  select.current:SetBackgroundColor(select.color.r, select.color.g, select.color.b, select.color.a)
  select.options = {} -- option frames
  select.optionTable = {} -- table with option data


  local function SelectHandler(num)
    if type(select.optionsTable[num][3]) == "function" then select.optionsTable[num][3](select.optionsTable[num][1], select.optionsTable[num][2]) end
    select:SetSelected(num)
    select.Event:SelectChange(num, select.optionsTable[num])
  end

 function select:toggleDropdown (bool)
    if select.enabled == true then
    if select.optionsTable then
    for i, v in pairs(select.optionsTable) do --Frames
    if bool then select.options[i]:SetVisible(not bool) else select.options[i]:SetVisible((not select.options[i]:GetVisible())) end   --show
    end
    end
    end
  end
  function select.current.Event:LeftClick()
      select:toggleDropdown()
  end

   -- Functions that we can call:

  function select:GetSelected()
    return select.optionsTable[select.selected]
  end

  function select:SetSelected(data)
    local num
    if type(data) == "table" then
      data = data[1]
    end
    if type(data) == "string" then
      for i, v in pairs(select.optionsTable) do
        if v[1] == data then
          num = i
        end
      end
    elseif type(data) == "number" then
      num = data
    end
    select.selected = num
    self.current:SetText(self.optionsTable[num][2])
  end

  local oldSetWidth = select.SetWidth
  function select:SetWidth(width)
    oldSetWidth(select, width)
    for i, v in ipairs(self.options) do
      v:SetWidth(width)
    end
  end
  function select:SetEnabled(bool)
    self.enabled = bool
    if self.enabled == false then
      self.current:SetFontColor(0.5,0.5,0.5)
    else
      self.current:SetFontColor(1,1,1)
    end
  end


  select.Event = {}
  function select.Event:SelectChange() end

  function select:SetOptions(options)
    -- Set my table to the new options
    self.optionsTable = options
    for i, v in ipairs(self.options) do
      v:SetVisible(false)
    end
    if not select.lastOption then select.lastOption = nil end
    --iterate through the options table and add settings
    for i, v in ipairs(self.optionsTable) do -- v is a table
      local newOption
      if not self.options[i] then
        self.options[i] = UI.CreateFrame("Text", "Option " .. i, parent:GetParent())
        newOption = self.options[i]
        newOption.border = UI.CreateFrame("FluffBorder","dropdown Border",newOption)
        newOption.border:SetBorderWidth(0,1)
        newOption.border:SetBorderColor(0.77,0.7,0.35, 0.3)
        newOption:SetLayer(9999999)
        newOption:SetBackgroundColor(select.color.r, select.color.g, select.color.b, select.color.a)
        newOption:SetWidth(self:GetWidth())
        newOption:SetHeight(20)
        function newOption.Event.MouseIn()
          newOption:SetBackgroundColor(select.mouseoverColor.r, select.mouseoverColor.g, select.mouseoverColor.b, select.mouseoverColor.a)
        end
        function newOption.Event.MouseOut()
          newOption:SetBackgroundColor(select.color.r, select.color.g, select.color.b, select.color.a)
        end
        function newOption.Event.LeftClick()
          SelectHandler(i)
          self:toggleDropdown(true)
        end
        if not select.lastOption then
          newOption:SetPoint("TOPLEFT", self, "BOTTOMLEFT")
          select.lastOption = self.options[i]
        else
          newOption:SetPoint("TOPLEFT", select.lastOption, "BOTTOMLEFT")
          select.lastOption = self.options[i]
        end
      else
        newOption = self.options[i]
      end

      newOption:SetVisible(false)
      newOption:SetText(self.optionsTable[i][2])
    end
    select.lastOption.border:SetBorderWidth(0,1, 1, 1)
  end

  return select
end