---------------------------------------------------------------------------------------
---- FUNCTION DOCUMENTATION
---------------------------------------------------------------------------------------
---- Archimedes.AddArc (name, group, type, unit, specifier, offsetx, offsety, scale, foregroundID, backgroundID)
-------- Adds an arc's settings to the setup, these are then saved in the settings
-------- specifier = stat name for now, other will come
-----------------------------------------------------------------------------------
Archimedes = {}


Archimedes.defaultOptions = {
  globals = {
    spacing = 250,
    disabled = false,
    alpha = 1,
    combatAlpha = 1
  },
  arc = {
    group = "left",
    offsetx = 0,
    offsety = 0,
	specifier = "health",
	type = "stat",
	unit = "player",
    scale = 0.8,
    texture = "green",
    skinPack = "DefaultSkin",
    alpha = 1
  }
}

-- First run settings
Archimedes_Options = {
  globals = {
    spacing = 250,
    disabled = false,
    alpha = 1,
    combatAlpha = 1
  },
  -- These are the default arc settings
  arcs = {
   def1 = {
      group = "right",
      name = "Target Health",
      offsetx = 0,
      offsety = 0,
	  specifier = "health",
	  type = "stat",
	  unit = "player.target",
      scale = 0.8,
      texture = "green",
      skinPack = "DefaultSkin",
      alpha = 1
   },
   def2 = {
	  group = "right",
	  name = "Target Mana",
	  offsetx = 25,
	  offsety = 0,
	  specifier = "mana",
	  type = "stat",
	  unit = "player.target",
      scale = 0.8,
      texture = "blue",
      skinPack = "DefaultSkin",
      alpha = 1
    },
   def3 = {
	  group = "right",
	  name = "Target Power",
	  offsetx = 25,
	  offsety = 0,
	  specifier = "power",
	  type = "stat",
	  unit = "player.target",
      scale = 0.8,
      texture = "yellow",
      skinPack = "DefaultSkin",
      alpha = 1
   },
   def4 = {
	  group = "right",
	  name = "Target Energy",
	  offsetx = 25,
	  offsety = 0,
	  specifier = "energy",
	  type = "stat",
	  unit = "player.target",
      scale = 0.8,
      texture = "purple",
      skinPack = "DefaultSkin",
      alpha = 1
   },
   def5 = {
	  group = "left",
	  name = "Player Health",
	  offsetx = 0,
	  offsety = 0,
	  specifier = "health",
	  type = "stat",
	  unit = "player",
      scale = 0.8,
      texture = "green",
      skinPack = "DefaultSkin",
      alpha = 1
   },
   def6 = {
	  group = "left",
	  name = "Player Mana",
	  offsetx = -25,
	  offsety = 0,
	  specifier = "mana",
	  type = "stat",
	  unit = "player",
      scale = 0.8,
      texture = "blue",
      skinPack = "DefaultSkin",
      alpha = 1
    },
   def7 = {
	  group = "left",
	  name = "Player Power",
	  offsetx = -25,
	  offsety = 0,
	  specifier = "power",
	  type = "stat",
	  unit = "player",
      scale = 0.8,
      texture = "yellow",
      skinPack = "DefaultSkin",
      alpha = 1
   },
   def8 = {
	  group = "left",
	  name = "Player Energy",
	  offsetx = -25,
	  offsety = 0,
	  specifier = "energy",
	  type = "stat",
	  unit = "player",
      scale = 0.8,
      texture = "purple",
      skinPack = "DefaultSkin",
      alpha = 1
   },
   def9 = {
      group = "left",
	  name = "Player Charge",
	  offsetx = -50,
	  offsety = 0,
	  specifier = "charge",
	  type = "stat",
	  unit = "player",
      scale = 0.8,
      texture = "teal",
      skinPack = "DefaultSkin",
      alpha = 1
   }
  }
}
