Archimedes.Settings = {}
Archimedes.Settings.context = UI.CreateContext("Archimedes Settings")
Archimedes.Settings.initialised = false
--Toggle the visibility (overwritten by Init function)
function Archimedes.Settings:toggle()
  if self.initialised == false
  then self.Init() end
  self.window:SetVisible(true)
end

function Archimedes.Settings.Init()


-----------------
---- UTILITIES
----------------------------


function Archimedes:ReloadGlobals()
  Archimedes.side.right:SetPoint("CENTERLEFT", UIParent, "CENTER", Archimedes.Options.globals.spacing, 0)
  Archimedes.side.left:SetPoint("CENTERRIGHT", UIParent, "CENTER", 0 - Archimedes.Options.globals.spacing, 0)
  Archimedes.side.right:SetAlpha(Archimedes.Options.globals.alpha)
  Archimedes.side.left:SetAlpha(Archimedes.Options.globals.alpha)
  Archimedes.Visibility()
end



-----------------
---- Settings window
-----------------------------
Archimedes.Settings.window = UI.CreateFrame("RiftWindow","Settings",Archimedes.Settings.context)
Archimedes.Settings.window:SetVisible(false)
Archimedes.Settings.window:SetTitle("ARCHIMEDES SETTINGS")
Archimedes.Settings.window:SetPoint("CENTER", UIParent, "CENTER")
Archimedes.Settings.window:SetWidth(550)
Archimedes.Settings.window:SetHeight(500)
Archimedes.Settings.window:SetLayer(9999999)
Archimedes.Settings.window.border = Archimedes.Settings.window:GetBorder()
Archimedes.Settings.window.content = Archimedes.Settings.window:GetContent()

-------------------------
---- Window properties and controllers
---------------------------------------------

-- Close button
Archimedes.Settings.window.closeButton = UI.CreateFrame("RiftButton", "Close", Archimedes.Settings.window)
Archimedes.Settings.window.closeButton:SetPoint("BOTTOMRIGHT", Archimedes.Settings.window:GetContent(), "TOPRIGHT", 5, -5)
Archimedes.Settings.window.closeButton:SetSkin("close")
Archimedes.Settings.window.closeButton:SetLayer(10)

function Archimedes.Settings.window.closeButton.Event:LeftPress()
  Archimedes.Settings:toggle()
end

-- Toggle window
function Archimedes.Settings:toggle()
  self.window:SetVisible(not self.window:GetVisible())
  Library.LibFluff.ClearKeyFocus()
end


-- Draggable (but only on the border) Only working on PTS so far but it should automatically work once the live API is updated
Archimedes.Settings.titleDragger = UI.CreateFrame("Frame", "Draggable title", Archimedes.Settings.window)
Archimedes.Settings.titleDragger:SetAllPoints()
Archimedes.Settings.titleDragger:SetPoint("BOTTOM", Archimedes.Settings.window:GetContent(), "TOP")
--function Archimedes.Settings.window.content.Event:LeftDown() return end
function Archimedes.Settings.titleDragger.Event:LeftDown()
  local cMouse = Inspect.Mouse()
    local holdx = Archimedes.Settings.window:GetLeft()
    local holdy = Archimedes.Settings.window:GetTop()
    local holdw = Archimedes.Settings.window:GetWidth()
    local holdh = Archimedes.Settings.window:GetHeight()
    self.OffsetX = cMouse.x - holdx
    self.OffsetY = cMouse.y - holdy
    self.MouseDown = true
    Archimedes.Settings.window:ClearAll()
    Archimedes.Settings.window:SetWidth(holdw)
    Archimedes.Settings.window:SetHeight(holdh)
    Archimedes.Settings.window:SetPoint("TOPLEFT", UIParent, "TOPLEFT", holdx, holdy)
end
function Archimedes.Settings.titleDragger.Event:MouseMove(newX, newY)
    if self.MouseDown then
        Archimedes.Settings.window:SetPoint("TOPLEFT", UIParent, "TOPLEFT", newX - self.OffsetX, newY - self.OffsetY)
    end
end
function Archimedes.Settings.titleDragger.Event:LeftUp()
    if self.MouseDown then
        self.MouseDown = false
    end
end
function Archimedes.Settings.titleDragger.Event:LeftUpoutside()
    if self.MouseDown then
        self.MouseDown = false
    end
end
-----------------
---- Window SIDEBAR
----------------------------
Archimedes.Settings.zombieSideItems = {}
Archimedes.Settings.activeSideItems = {}
--Global settings
-- Etceteral
-- Divider
-- Arcs
-- Left/Right (expandible)
Archimedes.Settings.sidebar = UI.CreateFrame("Mask","Settings Sidebar",Archimedes.Settings.window.content);
Archimedes.Settings.sidebar:SetPoint("TOPLEFT", Archimedes.Settings.window.content, "TOPLEFT", 0, 5)
Archimedes.Settings.sidebar:SetPoint("BOTTOMRIGHT", Archimedes.Settings.window.content, "BOTTOMRIGHT")

Archimedes.Settings.sidebar:SetBackgroundColor(0,0,0, 0.3)
Archimedes.Settings.sidebar:SetPoint("RIGHT", Archimedes.Settings.window.content, "LEFT", 150, nil)
Archimedes.Settings.sidebar.borderRight = UI.CreateFrame("Frame","Settings Sidebar Border",Archimedes.Settings.sidebar)
Archimedes.Settings.sidebar:SetLayer(-1)
Archimedes.Settings.sidebar.borderRight:SetWidth(1)
Archimedes.Settings.sidebar.borderRight:SetLayer(-1)
Archimedes.Settings.sidebar.borderRight:SetPoint("TOPRIGHT", Archimedes.Settings.sidebar, "TOPRIGHT")
Archimedes.Settings.sidebar.borderRight:SetPoint("BOTTOMRIGHT", Archimedes.Settings.sidebar, "BOTTOMRIGHT")
Archimedes.Settings.sidebar.borderRight:SetBackgroundColor(0.77,0.7,0.35, 0.3)

Archimedes.Settings.sidebar.borderTop = UI.CreateFrame("Frame","Settings Top Border",Archimedes.Settings.window)
Archimedes.Settings.sidebar.borderTop:SetHeight(1)
Archimedes.Settings.sidebar.borderTop:SetLayer(2)
Archimedes.Settings.sidebar.borderTop:SetPoint("BOTTOMLEFT", Archimedes.Settings.sidebar, "TOPLEFT")
Archimedes.Settings.sidebar.borderTop:SetPoint("RIGHT", Archimedes.Settings.sidebar, "RIGHT")
Archimedes.Settings.sidebar.borderTop:SetBackgroundColor(0.77,0.7,0.35, 0.3)

Archimedes.Settings.sidebar.itemBorder = UI.CreateFrame("FluffBorder","Input Border",Archimedes.Settings.sidebar)
Archimedes.Settings.sidebar.itemBorder:SetBorderColor(0.77,0.7,0.35, 0.3)

Archimedes.Settings.sidebar.lastItem = nil
Archimedes.Settings.sidebar.selected = nil

function Archimedes.Settings.CreateSideItem(cat, arc, opt)
--Creates each sidebar item one by one
  local item = table.remove(Archimedes.Settings.zombieSideItems)
  if not item then
    item = UI.CreateFrame("Text","Settings Item", Archimedes.Settings.sidebar)
    item:SetFontColor(1,1,1)
	item:SetFontSize(12)
    item:SetWidth(149)
    item:SetHeight(20)
    item:SetBackgroundColor(0,0,0,0.3)
    item:SetWordwrap(false)

    --Select an item
  end
  item:SetBackgroundColor(0,0,0,0.3)
  if cat == "arcSettings" then
  function item:Select()
    if self == Archimedes.Settings.sidebar.selected then
    -- if I'm the selected, then deselect
      self:SetBackgroundColor(0,0,0,0.3)
      self:SetWidth(149)
      Archimedes.Settings.sidebar.itemBorder:SetBorderWidth(0)
      Library.LibFluff.ClearKeyFocus()
      Archimedes.Settings.arcSettings:SetVisible(false)
      Archimedes.Settings.sidebar.selected = nil
      return
    end
    if Archimedes.Settings.sidebar.selected then
      Archimedes.Settings.sidebar.selected:Select() --The function will toggle the original selected and deselect, it should also temporarily hide the settings
    end
    Archimedes.Settings.UpdateSettings(arc)
    Archimedes.Settings.arcSettings:SetVisible(true)
    self:SetBackgroundColor(0.05,0.05,0.05,1)
    self:SetWidth(152)
    Archimedes.Settings.sidebar.itemBorder:SetParent(self)
    Archimedes.Settings.sidebar.itemBorder:SetBorderWidth(1)
    Archimedes.Settings.sidebar.selected = self
  end
    function item.Event:LeftClick()
      self:Select()
    end
  item:SetText(opt.name)

  elseif cat == "globalSettings" then
    item:SetText("Global Settings")
      function item:Select()
      if self == Archimedes.Settings.sidebar.selected then
      -- if I'm the selected, then deselect
      self:SetBackgroundColor(0,0,0,0.3)
      self:SetWidth(149)
      Archimedes.Settings.sidebar.itemBorder:SetBorderWidth(0)
      Library.LibFluff.ClearKeyFocus()
      Archimedes.Settings.globalSettings:SetVisible(false)
      Archimedes.Settings.sidebar.selected = nil
      return
    end
    if Archimedes.Settings.sidebar.selected then
      Archimedes.Settings.sidebar.selected:Select() --The function will toggle the original selected and deselect, it should also temporarily hide the settings
    end
    --Archimedes.Settings.UpdateSettings()
      for _, v in pairs(Archimedes.Settings.globalSettings.rows) do
      v:SetNew()
      end

    Archimedes.Settings.globalSettings:SetVisible(true)
    self:SetBackgroundColor(0.05,0.05,0.05,1)
    self:SetWidth(152)
    Archimedes.Settings.sidebar.itemBorder:SetParent(self)
    Archimedes.Settings.sidebar.itemBorder:SetBorderWidth(1)
    Archimedes.Settings.sidebar.selected = self
  end
    function item.Event:LeftClick()
      self:Select()
    end
  elseif cat == "addArc" then
    item:SetText("+ Add Arc")
    item:SetBackgroundColor(0,0.05,0,0.5)
    function item.Event:LeftClick()
      local new = Archimedes.NewArc()
      --Archimedes.Settings.DrawSidebar()
      Archimedes.activeArcs[new]:ReloadSettings()
      Archimedes.Settings.CreateSideItem("arcSettings", new, Archimedes.Options.arcs[new])
      item:SetPoint("TOPLEFT", Archimedes.Settings.sidebar.lastItem, "BOTTOMLEFT", 0, 1)
      Archimedes.Settings.activeSideItems[new]:Select()
    end
  end
  if not Archimedes.Settings.sidebar.lastItem then
    item:SetPoint("TOPLEFT", Archimedes.Settings.sidebar, "TOPLEFT")
  elseif Archimedes.Settings.sidebar.lastItem:GetText() == "Global Settings" then
    item:SetPoint("TOPLEFT", Archimedes.Settings.sidebar.lastItem, "BOTTOMLEFT", 0, 5)
  else
    item:SetPoint("TOPLEFT", Archimedes.Settings.sidebar.lastItem, "BOTTOMLEFT", 0, 1)
  end
  item:SetVisible(true)
  if cat ~= "addArc" then
    Archimedes.Settings.sidebar.lastItem = item
    Archimedes.Settings.addArc = item
  end
  if arc then
    Archimedes.Settings.activeSideItems[arc] = item
  elseif cat == "globalSettings" then
    Archimedes.Settings.activeSideItems.globalSettings = item
  else
  table.insert(Archimedes.Settings.activeSideItems, item)
  end

end




-----------------
---- SETTINGS
----------------------------

Archimedes.Settings.arcSettings = UI.CreateFrame("Frame","Settings settings",Archimedes.Settings.window)
Archimedes.Settings.arcSettings:SetVisible(false)
Archimedes.Settings.arcSettings:SetPoint("TOPLEFT", Archimedes.Settings.sidebar, "TOPRIGHT", 0, 5)
Archimedes.Settings.arcSettings:SetPoint("TOPRIGHT", Archimedes.Settings.window.content, "TOPRIGHT", 0, 5)
Archimedes.Settings.arcSettings:SetPoint("BOTTOMLEFT", Archimedes.Settings.sidebar, "BOTTOMRIGHT")
Archimedes.Settings.arcSettings:SetPoint("BOTTOMRIGHT", Archimedes.Settings.window.content, "BOTTOMRIGHT")
Archimedes.Settings.arcSettings:SetBackgroundColor(0,0,0, 0.8)


Archimedes.Settings.globalSettings = UI.CreateFrame("Frame","Settings settings",Archimedes.Settings.window)
Archimedes.Settings.globalSettings:SetVisible(false)
Archimedes.Settings.globalSettings:SetPoint("TOPLEFT", Archimedes.Settings.sidebar, "TOPRIGHT", 0, 5)
Archimedes.Settings.globalSettings:SetPoint("TOPRIGHT", Archimedes.Settings.window.content, "TOPRIGHT", 0, 5)
Archimedes.Settings.globalSettings:SetPoint("BOTTOMLEFT", Archimedes.Settings.sidebar, "BOTTOMRIGHT")
Archimedes.Settings.globalSettings:SetPoint("BOTTOMRIGHT", Archimedes.Settings.window.content, "BOTTOMRIGHT")
Archimedes.Settings.globalSettings:SetBackgroundColor(0,0,0, 0.8)



Archimedes.Settings.arcSettings.borderTop = UI.CreateFrame("Frame","Settings Top Border",Archimedes.Settings.window)
Archimedes.Settings.arcSettings.borderTop:SetHeight(1)
Archimedes.Settings.arcSettings.borderTop:SetLayer(2)
Archimedes.Settings.arcSettings.borderTop:SetPoint("BOTTOMLEFT", Archimedes.Settings.arcSettings, "TOPLEFT")
Archimedes.Settings.arcSettings.borderTop:SetPoint("RIGHT", Archimedes.Settings.arcSettings, "RIGHT")
Archimedes.Settings.arcSettings.borderTop:SetBackgroundColor(0.77,0.7,0.35, 0.3)



--------------------
---- Setting row creators
---------------------------------

function Archimedes.Settings.NewRow(data)
  local row = UI.CreateFrame("Frame","Setting row " .. data.rowname,Archimedes.Settings[data.category])
  row:SetPoint("TOPLEFT", Archimedes.Settings.arcSettings, "TOPLEFT")
  row:SetHeight(50)
  return row
end

function Archimedes.Settings.GenerateRow(data)
  local row = Archimedes.Settings.NewRow(data)
  row.settings = {}
  for settingName, opt in ipairs(data.settings) do
    row[opt.optionname] = Archimedes.Settings.Add[opt.type](opt.label, row, opt.optionname, opt.options, data.category, opt.settingChange, opt.setNewNew)
    row.lastSetting = row[opt.optionname].label
    table.insert(row.settings, opt.optionname)
  end
  function row:SetNew()
    for i, v in pairs(row.settings) do
      row[v]:SetNew()
    end
  end
  Archimedes.Settings.PlaceMe(row, data.category)
  return row
end

Archimedes.Settings.Add = {}

function Archimedes.Settings.Add.input(label, row, optionname, options, category, settingChange)
  local input = UI.CreateFrame("RiftTextfield","Settings settings",Archimedes.Settings[category])
  input.label = UI.CreateFrame("Text","Input label",row)
  input.label:SetFontColor(0.77,0.7,0.35, 0.3)
  input.label:SetFontSize(10)
  input.label:SetHeight(10)
  input.label:SetWidth(150)
  input.label:SetText(label)
  if row.lastSetting then
    input.label:SetPoint("TOPLEFT", row.lastSetting, "TOPRIGHT", 20, 0)
  else
    input.label:SetPoint("TOPLEFT", row, "TOPLEFT")
  end

  input.optionname = optionname
  input:SetPoint("TOPLEFT", input.label, "BOTTOMLEFT", 0, 5)
  input:SetWidth(options.width or 150)
  input:SetBackgroundColor(0,0,0, 0.8)
  input.border = UI.CreateFrame("FluffBorder","Input Border",input)
  input.border:SetBorderWidth(1)
  input.border:SetBorderColor(0.77,0.7,0.35, 0.3)
  if category == "arcSettings" then
  function input:SetNew()
    function self.Event:TextfieldChange()
      if options.num == true then  -- If it's numeral, only save numbers
        if type(tonumber(self:GetText())) == "number" then
          Archimedes.Options.arcs[Archimedes.Settings.currentArc][optionname] = tonumber(self:GetText())
          if settingChange then settingChange(tonumber(self:GetText())) end
          self.border:SetBorderColor(0.77,0.7,0.35, 0.3)
        else
          self.border:SetBorderColor(1, 0, 0, 0.3)
        end
      else
        Archimedes.Options.arcs[Archimedes.Settings.currentArc][optionname] = self:GetText()
        if settingChange then settingChange(self:GetText()) end
        Archimedes.activeArcs[Archimedes.Settings.currentArc]:ReloadSettings()
      end
      Archimedes.activeArcs[Archimedes.Settings.currentArc]:ReloadSettings()
    end
    self:SetText(tostring(Archimedes.Options.arcs[Archimedes.Settings.currentArc][optionname]))
  end
  else
    function input:SetNew()
      function self.Event:TextfieldChange()
        if options.num == true then  -- If it's numeral, only save numbers
          if type(tonumber(self:GetText())) == "number" then
            Archimedes.Options.globals[optionname] = tonumber(self:GetText())
            if settingChange then settingChange(self:GetText()) end
            self.border:SetBorderColor(0.77,0.7,0.35, 0.3)
          else
            self.border:SetBorderColor(1, 0, 0, 0.3)
          end
        else
          Archimedes.Options.globals[optionname] = self:GetText()
          if settingChange then settingChange(self:GetText()) end
        end
        Archimedes:ReloadGlobals()
      end
      self:SetText(tostring(Archimedes.Options.globals[optionname]))
    end
  end
  return input
end

function Archimedes.Settings.Add.checkbox(label, row, optionname, options, category, settingChange)
  local checkbox = UI.CreateFrame("RiftCheckbox","Settings settings",Archimedes.Settings[category])
  checkbox.label = UI.CreateFrame("Text","Input label",row)
  checkbox.label:SetFontColor(0.77,0.7,0.35, 0.3)
  checkbox.label:SetFontSize(10)
  checkbox.label:SetWidth(135)
  checkbox.label:SetText(label)
  if row.lastSetting then
    checkbox.label:SetPoint("LEFT", row.lastSetting, "RIGHT", 35, nil)
    checkbox.label:SetPoint("CENTERY", row, "CENTERY")
  else
    checkbox.label:SetPoint("CENTERLEFT", row, "CENTERLEFT", 15, 0)
  end
  checkbox:SetPoint("TOPRIGHT", checkbox.label, "TOPLEFT", 0, 0)

  checkbox.optionname = optionname
  function checkbox.Event:CheckboxChange() end

  if category == "globalSettings" then
  function checkbox:SetNew()
    function self.Event:CheckboxChange()
      Archimedes.Options.globals[optionname] = self:GetChecked()
      if settingChange then settingChange(self:GetChecked()) end
      Archimedes:ReloadGlobals()
    end
    self:SetChecked(false or Archimedes.Options.globals[optionname])
  end
  elseif category == "arcSettings" then
  function checkbox:SetNew()
    function self.Event:CheckboxChange()
      Archimedes.Options.arcs[Archimedes.Settings.currentArc][optionname] = self:GetChecked()
      if settingChange then settingChange(self:GetChecked()) end
      Archimedes.activeArcs[Archimedes.Settings.currentArc]:ReloadSettings()
    end
    self:SetChecked(false or Archimedes.Options.arcs[Archimedes.Settings.currentArc][optionname])
  end
  end
  return checkbox
end

function Archimedes.Settings.Add.dropdown(label, row, optionname, options, category, settingChange, setNewNew)
  local dropdown = UI.CreateFrame("FluffSelect","Settings settings",Archimedes.Settings[category])
  dropdown.label = UI.CreateFrame("Text","Input label",row)
  dropdown.label:SetFontColor(0.77,0.7,0.35, 0.3)
  dropdown.label:SetFontSize(10)
  dropdown.label:SetHeight(10)
  dropdown.label:SetWidth(150)
  dropdown.label:SetPoint("TOPLEFT", row, "TOPLEFT")
  dropdown.label:SetText(label)
  if row.lastSetting then
    dropdown.label:SetPoint("TOPLEFT", row.lastSetting, "TOPRIGHT", 20, 0)
  else
    dropdown.label:SetPoint("TOPLEFT", row, "TOPLEFT", 0, 0)
  end

  dropdown.optionname = optionname
  --dropdown:SetVisible(false)
  --dropdown:SetLayer(-1)
  dropdown:SetPoint("TOPLEFT", dropdown.label, "BOTTOMLEFT", 0, 5)
  dropdown:SetWidth(options.width or 150)
  dropdown.border = UI.CreateFrame("FluffBorder","Input Border",dropdown)
  dropdown.border:SetBorderWidth(1)
  dropdown.border:SetBorderColor(0.77,0.7,0.35, 0.3)
  if options.select then dropdown:SetOptions(options.select) end
  function dropdown:SetNew()
    if setNewNew then setNewNew(self) end
    self:toggleDropdown(true)
    if Archimedes.Options.arcs[Archimedes.Settings.currentArc][optionname] == "unavailable" then dropdown.current:SetText("Unavailable") dropdown:SetEnabled(false) return
    else
      dropdown:SetEnabled(true)
    end
    function self.Event:SelectChange(num, table)
      Archimedes.Options.arcs[Archimedes.Settings.currentArc][optionname] = table[1]
      if settingChange then settingChange(table[1]) end
      Archimedes.activeArcs[Archimedes.Settings.currentArc]:ReloadSettings()
    end
    dropdown:SetSelected(Archimedes.Options.arcs[Archimedes.Settings.currentArc][optionname])
  end
  return dropdown
end

function Archimedes.Settings.Add.slider(label, row, optionname, options, category, settingChange, setNewNew)
  local slider = UI.CreateFrame("RiftSlider","Settings slider",Archimedes.Settings[category])
  slider.label = UI.CreateFrame("Text","Input label",row)
  slider.label:SetFontColor(0.77,0.7,0.35, 0.3)
  slider.label:SetFontSize(10)
  slider.label:SetHeight(10)
  slider.label:SetPoint("TOPLEFT", row, "TOPLEFT")
  slider.label:SetWidth(150)
  slider.label:SetText(label)
  if row.lastSetting then
    slider.label:SetPoint("TOPLEFT", row.lastSetting, "TOPRIGHT", 20, 0)
  else
    slider.label:SetPoint("TOPLEFT", row, "TOPLEFT", 0, 0)
  end
  slider.optionname = optionname
  slider:SetPoint("TOPLEFT", slider.label, "BOTTOMLEFT", 0, 5)
  slider:SetWidth(options.width or 150)
  slider.sliderLabel = UI.CreateFrame("RiftTextfield","Settings slider input",slider)
  slider.sliderLabel:SetPoint("TOPLEFT", slider, "TOPRIGHT", 10, -6)
  slider.sliderLabel:SetWidth(35)
  slider.sliderLabel:SetBackgroundColor(0,0,0, 0.8)
  slider.sliderLabel.border = UI.CreateFrame("FluffBorder","Slider Label Border",slider.sliderLabel)
  slider.sliderLabel.border:SetBorderWidth(1)
  slider.sliderLabel.border:SetBorderColor(0.77,0.7,0.35, 0.3)
  if options then if options.slider then
        slider:SetRange(options.slider.min,options.slider.max)
  end end
  if category == "arcSettings" then

  function slider:SetNew()
    function self.Event:SliderChange()
      Archimedes.Options.arcs[Archimedes.Settings.currentArc][optionname] = self:GetPosition()*options.slider.scale
      self.sliderLabel:SetText(tostring(self:GetPosition()*options.slider.scale))
      Archimedes.activeArcs[Archimedes.Settings.currentArc]:ReloadSettings()
    end
    function self.sliderLabel.Event:TextfieldChange()
        if type(tonumber(self:GetText())) == "number" and ((tonumber(self:GetText()) <= options.slider.max*options.slider.scale) and (tonumber(self:GetText()) >= options.slider.min*options.slider.scale)) then
          Archimedes.Options.arcs[Archimedes.Settings.currentArc][optionname] = tonumber(self:GetText())
          self:GetParent():SetPosition(Archimedes.Options.arcs[Archimedes.Settings.currentArc][optionname]/options.slider.scale)
          self.border:SetBorderColor(0.77,0.7,0.35, 0.3)
        else
          self.border:SetBorderColor(1, 0, 0, 0.3)
        end
      Archimedes.activeArcs[Archimedes.Settings.currentArc]:ReloadSettings()
      --row.SettingChange()
    end
    local slidermin, slidermax = self:GetRange()
    self:SetPosition(Archimedes.Options.arcs[Archimedes.Settings.currentArc][optionname]/options.slider.scale)
    self.sliderLabel:SetText(tostring(self:GetPosition()*options.slider.scale))
  end

  elseif category == "globalSettings" then

    function slider:SetNew()
        function self.Event:SliderChange()

          Archimedes.Options.globals[optionname] = self:GetPosition()*options.slider.scale
          if settingChange then settingChange(self:GetPosition()*options.slider.scale) end
          self.sliderLabel:SetText(tostring(self:GetPosition()*options.slider.scale))
          Archimedes:ReloadGlobals()
        end
        function self.sliderLabel.Event:TextfieldChange()
            if type(tonumber(self:GetText())) == "number" and ((tonumber(self:GetText()) <= options.slider.max*options.slider.scale) and (tonumber(self:GetText()) >= options.slider.min*options.slider.scale)) then
              Archimedes.Options.globals[optionname] = tonumber(self:GetText())
              self:GetParent():SetPosition(Archimedes.Options.globals[optionname]/options.slider.scale)
              self.border:SetBorderColor(0.77,0.7,0.35, 0.3)
            else
              self.border:SetBorderColor(1, 0, 0, 0.3)
            end
            Archimedes:ReloadGlobals()
        end
        local slidermin, slidermax = self:GetRange()
        self:SetPosition(Archimedes.Options.globals[optionname]/options.slider.scale)
        self.sliderLabel:SetText(tostring(self:GetPosition()*options.slider.scale))
      end

  end
  return slider
end



function Archimedes.Settings.PlaceMe(row, group)
  if not Archimedes.Settings[group].lastSetting then
    row:SetPoint("TOPLEFT", Archimedes.Settings.arcSettings, "TOPLEFT", 10, 10)
  else
    row:SetPoint("TOPLEFT", Archimedes.Settings[group].lastSetting, "BOTTOMLEFT", 0, 0)
  end
  Archimedes.Settings[group].lastSetting = row
  --row:SetLayer(Archimedes.Settings[group].lastSetting:GetLayer() -1)
end



function Archimedes.Settings.UpdateSettings(arc)
  arc = arc or Archimedes.Settings.currentArc
  Archimedes.Settings.currentArc = arc
  Archimedes.Settings.currentTextList = Archimedes.textSelect[Archimedes.Options.arcs[arc].skinPack]
  for _, v in pairs(Archimedes.Settings.arcSettings.rows) do
    -- if the setting is "unavailable" then hide or lock it
    v:SetNew(arc)
  end
  Archimedes.Settings.deleteButton:SetNew(arc)
  Archimedes.Settings.copyButton:SetNew(arc)
end

  Archimedes.Settings.copyButton = UI.CreateFrame("RiftButton","Settings Copy Button",Archimedes.Settings.arcSettings)
  Archimedes.Settings.copyButton:SetPoint("BOTTOMRIGHT", Archimedes.Settings.arcSettings, "BOTTOMCENTER")
  Archimedes.Settings.copyButton:SetText("DUPLICATE")
  --Archimedes.Settings.copyButton:SetEnabled(false)
  function Archimedes.Settings.copyButton:SetNew(arc)
    function Archimedes.Settings.copyButton.Event:LeftPress()
      local copy = Archimedes.CopyArc(arc)
      Archimedes.Settings.DrawSidebar()
      Archimedes.Settings.activeSideItems[copy]:Select()
    end
  end
  Archimedes.Settings.deleteButton = UI.CreateFrame("RiftButton","Settings Delete Button",Archimedes.Settings.arcSettings)
  Archimedes.Settings.deleteButton:SetPoint("BOTTOMRIGHT", Archimedes.Settings.arcSettings, "BOTTOMRIGHT")
  Archimedes.Settings.deleteButton:SetText("DELETE")
  --Archimedes.Settings.deleteButton:SetEnabled(false)
  function Archimedes.Settings.deleteButton:SetNew(arc)
    function Archimedes.Settings.deleteButton.Event:LeftPress()
      Archimedes.RemoveArc (arc)
      Archimedes.Settings.DrawSidebar()
      if Archimedes.Settings.sidebar.selected then Archimedes.Settings.sidebar.selected:Select() end
    end
  end


--------------
---- DRAW CONTENT
------------------------

function Archimedes.Settings.DrawGlobalSettings()
  Archimedes.Settings.globalSettings.rows = {}

local globalSettingsTable = {
{
  rowname = "spacing",
  category = "globalSettings",
  settings = {
    {label = "Spacing:", type = "input", optionname = "spacing", options = {num = true} },
    {label = "Hide Archimedes",type = "checkbox", optionname = "disabled", options = {}}
  }
},
{
  rowname = "alpha",
  category = "globalSettings",
  settings = {
    {label = "Global Alpha:", type = "slider", optionname = "alpha", options = {slider = {min = 0, max = 100, scale = 0.01 }}}
  }
},
{
  rowname = "combatAlpha",
  category = "globalSettings",
  settings = {
    {label = "Combat Alpha:", type = "slider", optionname = "combatAlpha", options = {slider = {min = 0, max = 100, scale = 0.01 }}}
  }
},

}
for _, data in ipairs(globalSettingsTable) do
  Archimedes.Settings.globalSettings.rows[data.rowname] = Archimedes.Settings.GenerateRow(data)
end

end


function Archimedes.Settings.DrawArcSettings()

Archimedes.Settings.arcSettings.rows = {}

Archimedes.packSelect = {}
Archimedes.textSelect = {}

for pack, skin in pairs(Archimedes.skins) do
  table.insert(Archimedes.packSelect, {skin.pack, skin.packName}) -- Add the pack
  Archimedes.textSelect[pack] = {}
  for id, texture in pairs(skin.textures) do
    table.insert(Archimedes.textSelect[pack], {id, texture[1]})   -- Add the pack's textures to the appropriate list table
  end
end
Archimedes.Settings.currentTextList = Archimedes.textSelect.DefaultSkin

local arcSettingsTable = {
{
  rowname = "firstrow",
  category = "arcSettings",
  settings = {
    {label = "Name:", type = "input", optionname = "name", options = {},
      settingChange = function(new)
        Archimedes.Settings.activeSideItems[Archimedes.Settings.currentArc]:SetText(new)
      end }
  }
},
{
  rowname = "secondrow",
  category = "arcSettings",
  settings = {
    {label = "Type:",type = "dropdown", optionname = "type", options = {select = {{"stat", "Stat"}, {"castbar", "Castbar (experimental)"}}},
    settingChange =  function (new)
      if new == "castbar" then
        -- Set the specifier to unavailable
        Archimedes.Options.arcs[Archimedes.Settings.currentArc]["specifier"] = "unavailable"
        -- SetNew to refresh the new ("unavailable") value
        Archimedes.Settings.arcSettings.rows["secondrow"]:SetNew()
      else
        --Set the specifier to default
        Archimedes.Options.arcs[Archimedes.Settings.currentArc]["specifier"] = Archimedes.defaultOptions.arc.specifier
        -- SetNew to refresh the new (default) value
        Archimedes.Settings.arcSettings.rows["secondrow"]:SetNew()
      end
      Archimedes.ArcLoader()
    end
    },
    {label = "Specifier:", type = "dropdown", optionname = "specifier", options = {select = {{"health", "Health"}, {"mana", "Mana"}, {"energy", "Energy"}, {"power", "Power"}, {"charge", "Charge"}}},
      settingChange = Archimedes.ArcLoader
    }
  }
},
{
  rowname = "thirdrow",
  category = "arcSettings",
  settings = {
    {label = "Unit:", type = "dropdown", optionname = "unit", options = {
      select = {
      {"player", "Player"},
      {"player.target", "Target"},
      {"player.pet", "Pet" },
      {"focus", "Focus" },
      {"focus.target", "Focus' Target"},
      {"player.target.pet", "Target's Pet" },
      {"player.target.target", "Target of Target" },
      {"player.target.target.pet", "Target of Target's Pet" },
      {"player.target.target.target", "Target of Target of Target" },
      {"mouseover", "Mouseover" },
      }
      },
      settingChange = Archimedes.ArcLoader
    },
    {label = "Side:", type = "dropdown", optionname = "group", options = {select = {{"left", "Left"}, {"right", "Right"}}}
    }
    }
},
{
  rowname = "fourthrow",
  category = "arcSettings",
  settings = {
    {label = "Scale:", type = "slider", optionname = "scale", options = {slider = {min = 10, max = 150, scale = 0.01 }}}
  }
},
{
  rowname = "fifthrow",
  category = "arcSettings",
  settings = {
    {label = "Alpha:", type = "slider", optionname = "alpha", options = {slider = {min = 0, max = 100, scale = 0.01 }}}
  }
},
{
  rowname = "sixthrow",
  category = "arcSettings",
  settings = {
    {label = "Skin:", type = "dropdown", optionname = "skinPack", options = {select = Archimedes.packSelect },
      settingChange = function(new)
        --dump(Archimedes.textSelect[new][1][1])
        Archimedes.Options.arcs[Archimedes.Settings.currentArc]["texture"] = Archimedes.textSelect[new][1][1]
        Archimedes.Settings.arcSettings.rows["sixthrow"]["texture"]:SetOptions(Archimedes.textSelect[new])
        Archimedes.Settings.UpdateSettings(Archimedes.Settings.currentArc)
      end},
    {label = "Texture:",type = "dropdown", optionname = "texture", options = {select = Archimedes.Settings.currentTextList }, setNewNew = function(self) self:SetOptions(Archimedes.Settings.currentTextList)  end }
  }
},
{
    rowname = "seventhrow",
    category = "arcSettings",
    settings = {
      {label = "X-Offset:", type = "input", optionname = "offsetx", options = {num = true} },
      {label = "Y-Offset:", type = "input", optionname = "offsety", options = {num = true} }
    }
  },
}

for _, data in ipairs(arcSettingsTable) do
  Archimedes.Settings.arcSettings.rows[data.rowname] = Archimedes.Settings.GenerateRow(data)
end

end



function Archimedes.Settings.DrawSidebar()
  for _, v in pairs(Archimedes.Settings.activeSideItems) do
    table.insert(Archimedes.Settings.zombieSideItems, v)
    v:SetVisible(false)
    v:SetPoint("TOPLEFT", Archimedes.Settings.sidebar, "TOPLEFT")
  end
  Archimedes.Settings.activeSideItems = {}
  Archimedes.Settings.sidebar.lastItem = nil
  Archimedes.Settings.CreateSideItem("globalSettings")
  for arc,opt in pairs(Archimedes.Options.arcs) do
    Archimedes.Settings.CreateSideItem("arcSettings", arc, opt)
  end
  Archimedes.Settings.CreateSideItem("addArc")
end



Archimedes.Settings.DrawSidebar()
Archimedes.Settings.DrawArcSettings()
Archimedes.Settings.DrawGlobalSettings()
Archimedes.Settings.activeSideItems.globalSettings:Select()
Archimedes.Settings.initialised = true
end






